/*********************
SSJ4_Gohan_Majin's
		Battle System
*********************/
/********
Bug Reports = Dan321ny@AOL.com
********/

world
	mob = /mob/Game/

mob/Game
	Login()
		var/mob/new_mob
		new_mob = new/mob/character()
		new_mob.loc = locate(1,1,1)
		new_mob.name = key
		src.client.mob = new_mob
		del(src)
		..()

mob
	var
		hp = 100
		maxhp = 100
		exp = 0
		maxexp = 100
		level = 1
		strength = 5
		defense = 5

	Stat()
		..()
		statpanel("[src]'s Stats")
		stat("Health","[src.hp]/[src.maxhp]")
		stat("Level",src.level)
		stat("Experience","[src.exp]/[src.maxexp]")
		stat("Strength",src.strength)
		stat("Defense",src.defense)



	proc/death_check(mob/M as mob)//handles death
		if(src.hp <= 0)
			M <<"You killed [src]!"
			if(src.client)
				src <<"[M] killed you!"
				src.loc = locate(1,1,2)
				src.hp = src.maxhp
			else
				src <<"You have been killed by [M]!"
				del(src)




	proc/stat_up()
		src.strength += rand(2,10)
		src.defense += rand(3,10)
		src.maxhp += rand(1,5)
		src.hp = src.maxhp
		src <<"\blue You begin to feel stronger as your stats increase!"



	proc/level_up()
		if(src.client)
			if(src.exp >= src.maxexp)//if the players exp matches or is higher then the players maxexp
				src.stat_up()
				src.level += 1//adds a level
				src <<"\red You gained a Level!"//informs player that they gained a level
				src.maxexp *= 2//doubles the max exp by 2
				src.exp = 0//exp back to zero
		else
			return..()


	verb/Attack(mob/M in oview(1))
		set category = "Battle"
		var/damage = src.strength - M.defense
		if(M.client)
			M.hp -= damage
			src <<"You attack [M] for [damage]!"
			M <<"You are being attacked by [src]!"
			src.level_up()
			M.death_check(src)
		else
			M.hp -= damage
			src <<"You attack [M] for [damage]!"
			M <<"You are being attacked by [src]!"
			var/random = rand(1,3)
			if(random == 1)
				src.exp += 4
			if(random == 2)
				src.exp += 3
			if(random == 3)
				src.exp ++
			src.level_up()
			M.death_check(src)

mob
	villan
		Monster
			icon = 'MOB.dmi'
			name = "Monster"
			hp = 5
			strength = 3
			defense = 3
			var/mob/character/Player
			New()
				. = ..()
				spawn()
					move()
			proc/move()
				while(src)
					var/player_found = 0
					for(Player in oview(8,src))
						step_towards(src,Player)
						player_found = 1
						break
					if(player_found != 1)
						step_rand(src)
						sleep(10)
					sleep(5)

			Bump(mob/M)
				if(istype(M,/mob/character))
					attack(M)
			proc/attack(mob/M)
				var/damage = rand(1,strength)
				M.hp -= damage
				M <<"You are being attacked by [src]!"
				src.exp += rand(5,10)
				src.level_up()
				M.death_check(src)




mob
	character
		icon = 'auron.dmi'
		hp = 15
		maxhp = 15
		exp = 0
		maxexp = 100
		level = 1
		strength = 15
		defense = 6

turf
	grass
		icon = 'Turfs0.dmi'
		icon_state = "67"








