mob
	proc
		attack(mob/M)
			if(M) // always check if M is there
				src << "You attempt to attack [M]."
				M << "[src] attempts to attack you."
				sleep(10)
				if(rand(1,4)==4) // just some mini-dodging  you can change this if you want
					src << "[M] dodges your attack."
					M << "You dodge [src]'s attack."
				else
					var/damage = src.str - M.def // just like any RPG, strength minus defense equals damage =D
					if(damage<=0)
						damage = 1 // now if you're too weak, you don't heal them
					if(luckchance(src)) // criticles, the main procedure is in Main.dm
						damage = damage*2
						src << "Criticle hit!"
						M << "Criticle hit!"
						sleep(10)
					src << "You hit [M] for [damage] hit points."
					M << "[src] hits you for [damage] hit points."

					M.hp -= damage
					sleep(10) // this is so it doesn't get cluttered

					// deathcheck will be called in the actual battle, so less space is taken in the long run

		bighit(mob/M)
			if(M)
				src << "You attempt to bighit [M]."
				M << "[src] attempts to bighit you."
				sleep(10)
				if(rand(1,2)==2) // lower chance of hitting
					src << "[M] dodges your attack."
					M << "You dodge [src]'s attack."
				else
					var/damage = (src.str - M.def) + 15 // bigger damage, the ( and ) aren't needed but I use
					if(damage<=0)                       // them so it is more organised
						damage = 1
					if(luckchance(src)) // I wonder what'll happen if you criticle this o.O
						damage = damage*2
						src << "Criticle hit!"
						M << "Criticle hit!"
						sleep(10)

					src << "You hit [M] for [damage] hit points."
					M << "[src] hits you for [damage] hit points."

					M.hp -= damage
					sleep(10)

		zap(mob/M) // this proc is pretty much simular to attack and bighit, but there is just a different
				   // damage counter and it checks for your magic
			if(M)
				src << "You attempt to zap [M]."
				M << "[src] attempts to zap you."
				sleep(10)
				if(src.mp<5) // you can't just spam zap and never loose magic!
					src << "... but you need at least 5 MP to cast zap!"
					M << "... but [src] doesn't have enough magic left!"

				else
					src.mp -= 5
					var/damage = src.int + 5 - round(M.int/2) // this is just for fun, there is magic defence too
					if(damage<=0) // unless you're immune to electricity, I suggest you keep this there
						damage = 1
					src << "You zap [M] for [damage] hit points."
					M << "[src] zaps you for [damage] hit points."
					M.hp -= damage
					M.overlays += image('spell_effects.dmi',"zap") // check out the F1 reference for more details about this proc
					sleep(5)									   // we use sleep() because this is a realtime.  if we don't sleep, the battle will zoom out ahead before you can read it all
					M.overlays -= image('spell_effects.dmi',"zap") // some things are meant to die sooner or later

		bang(mob/M)
			if(M)
				src << "You attempt to bang [M]."
				M << "[src] attempts to bang you."
				sleep(10)
				if(src.mp<10)
					src << "... but you need at least 10 MP to cast bang!"
					M << "... but [src] doesn't have enough magic left!"

				else
					src.mp -= 10
					var/damage = src.int + 10 - round(M.int/2) // bigger and better damage
					if(damage<=0)
						damage = 1
					src << "You bang [M] for [damage] hit points."
					M << "[src] bang you for [damage] hit points."
					M.hp -= damage
					M.overlays += image('spell_effects.dmi',"bang")
					sleep(5)
					M.overlays -= image('spell_effects.dmi',"bang")



		heal(mob/M)
			src << "You cast heal."
			M << "[src] casts heal."
			sleep(10)
			if(src.mp<7)
				src << "... but you need at least 7 MP to cast heal!"
				M << "... but [src] doesn't have enough magic left!"

			else
				src.mp -= 7
				var/gain = src.int+7 //
				src << "You recover [gain] HP."
				M << "[src] recovers [gain] HP."
				src.hp += gain
//				if(src.hp > src.maxhp) src.hp = src.maxhp // You can still use this way to do this, but the following way is better and more efficient
				src.hp = min(src.maxhp,src.hp+gain) // this prodecure returns the smaller value
													// the max() proc takes the bigger value, for future reference
				src.overlays += image('spell_effects.dmi',"heal")
				sleep(5)
				src.overlays -= image('spell_effects.dmi',"heal")
